//
// JIMS ( http://forge.scilab.org/index.php/p/JIMS/ ) - This file is a part of JIMS
// Copyright (C) 2010 - 2011 - Calixte DENIZET <calixte@contrib.scilab.org>
// Copyright (C) 2011 - Allan CORNET  
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function jimsinit()
  if ~isdef("jnull") | ~isdef("jvoid") | ~isdef("!_invoke_") | ~isdef("!_deff_wrapper") then
    //Add a jnull object to wrap null
    _jnull = jwrap([]);
  
    //Add a jvoid object
    _jvoid = mlist(['_JVoid']);
  
    //These macros are used only for internal use.
    //The second is a workaround to the bug with SciString and deff
    deff('y = !_invoke_(varargin)', 'y = !!_invoke_l(varargin)', 'c');
    deff('!_deff_wrapper(name, definition, code)', 'deff(definition, code); execstr(name+''=resume(''+name+'')'')');

    [jvoid, jnull, !_invoke_, !_deff_wrapper] = resume(_jvoid, _jnull, !_invoke_, !_deff_wrapper);
  end
endfunction